"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Monitor = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const ink_1 = require("ink");
const colors_1 = require("./colors");
const confirmText = '- Press "Enter" to confirm';
const searchColor = colors_1.getSearchColor();
const replaceColor = colors_1.getReplaceColor();
const Monitor = ({ files, replace, searchRegExp, matches, }) => {
    const maxMonitorHeight = process.stdout.rows - 7;
    const totalFiles = files.length;
    const notInitialRender = react_1.useRef(false);
    // Prevent flickering on the no matched files
    // Warning (since we get the files after a few miliseconds)
    if (!notInitialRender.current) {
        notInitialRender.current = true;
        return jsx_runtime_1.jsx(jsx_runtime_1.Fragment, {}, void 0);
    }
    if (totalFiles === 0) {
        return (jsx_runtime_1.jsx(jsx_runtime_1.Fragment, { children: jsx_runtime_1.jsx(ink_1.Text, Object.assign({ dimColor: true, color: "yellow" }, { children: "no matched files for pattern" }), void 0) }, void 0));
    }
    if (!searchRegExp || matches.length === 0) {
        return (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [jsx_runtime_1.jsxs(ink_1.Text, Object.assign({ dimColor: true, color: "yellow" }, { children: [0, " / ", totalFiles, replace ? jsx_runtime_1.jsxs(ink_1.Text, { children: [" ", confirmText] }, void 0) : null] }), void 0),
                files
                    .map((filePath) => {
                    return (jsx_runtime_1.jsxs(ink_1.Text, { children: [filePath, replace ? jsx_runtime_1.jsx(ink_1.Text, { children: replaceColor `${replace}` }, void 0) : null] }, filePath));
                })
                    .slice(0, maxMonitorHeight)] }, void 0));
    }
    return (jsx_runtime_1.jsxs(jsx_runtime_1.Fragment, { children: [jsx_runtime_1.jsxs(ink_1.Text, Object.assign({ dimColor: true, color: "yellow" }, { children: [matches.length, " / ", totalFiles, " ", jsx_runtime_1.jsx(ink_1.Text, { children: confirmText }, void 0)] }), void 0),
            matches
                .map(({ filePath, match, matchStartIndex }) => {
                return (jsx_runtime_1.jsxs(ink_1.Text, { children: [jsx_runtime_1.jsx(ink_1.Text, { children: filePath.substr(0, matchStartIndex) }, void 0),
                        jsx_runtime_1.jsx(ink_1.Text, Object.assign({ strikethrough: true }, { children: searchColor `${match}` }), void 0),
                        replace ? jsx_runtime_1.jsx(ink_1.Text, { children: replaceColor `${replace}` }, void 0) : null,
                        jsx_runtime_1.jsx(ink_1.Text, { children: filePath.substr(matchStartIndex + match.length) }, void 0)] }, filePath));
            })
                .slice(0, maxMonitorHeight)] }, void 0));
};
exports.Monitor = Monitor;
